v17tx.c File Reference
`#include <stdio.h>`
`#include <inttypes.h>`
`#include <stdlib.h>`
`#include <string.h>`
`#include "floating_fudge.h"`
`#include "spandsp/telephony.h"`
`#include "spandsp/fast_convert.h"`
`#include "spandsp/logging.h"`
`#include "spandsp/complex.h"`
`#include "spandsp/vector_float.h"`
`#include "spandsp/complex_vector_float.h"`
`#include "spandsp/vector_int.h"`
`#include "spandsp/complex_vector_int.h"`
`#include "spandsp/async.h"`
`#include "spandsp/dds.h"`
`#include "spandsp/power_meter.h"`
`#include "spandsp/v17tx.h"`
`#include "spandsp/private/logging.h"`
`#include "spandsp/private/v17tx.h"`
`#include "v17_v32bis_tx_constellation_maps.h"`
`#include "v17_v32bis_tx_floating_rrc.h"`

## Macros

#define | CARRIER_NOMINAL_FREQ 1800.0f
#define | V17_TRAINING_SEG_TEP_A 0
#define | V17_TRAINING_SEG_TEP_B (V17_TRAINING_SEG_TEP_A + 480)
#define | V17_TRAINING_SEG_1 (V17_TRAINING_SEG_TEP_B + 48)
#define | V17_TRAINING_SEG_2 (V17_TRAINING_SEG_1 + 256)
#define | V17_TRAINING_SEG_3 (V17_TRAINING_SEG_2 + 2976)
#define | V17_TRAINING_SEG_4 (V17_TRAINING_SEG_3 + 64)
#define | V17_TRAINING_SHORT_SEG_4 (V17_TRAINING_SEG_2 + 38)
#define | V17_TRAINING_END (V17_TRAINING_SEG_4 + 48)
#define | V17_TRAINING_SHUTDOWN_A (V17_TRAINING_END + 32)
#define | V17_TRAINING_SHUTDOWN_END (V17_TRAINING_SHUTDOWN_A + 48)
#define | V17_BRIDGE_WORD 0x8880

## Functions

int | v17_tx (v17_tx_state_t *s, int16_t amp[], int len)
void | v17_tx_power (v17_tx_state_t *s, float power)
| Adjust a V.17 modem transmit context's output power.
void | v17_tx_set_get_bit (v17_tx_state_t *s, get_bit_func_t get_bit, void *user_data)
| Change the get_bit function associated with a V.17 modem transmit context.
void | v17_tx_set_modem_status_handler (v17_tx_state_t *s, modem_status_func_t handler, void *user_data)
| Change the modem status report function associated with a V.17 modem transmit context.
logging_state_t * | v17_tx_get_logging_state (v17_tx_state_t *s)
| Get the logging context associated with a V.17 modem transmit context.
int | v17_tx_restart (v17_tx_state_t *s, int bit_rate, int tep, int short_train)
| Reinitialise an existing V.17 modem transmit context.
v17_tx_state_t * | v17_tx_init (v17_tx_state_t *s, int bit_rate, int tep, get_bit_func_t get_bit, void *user_data)
| Initialise a V.17 modem transmit context.
int | v17_tx_release (v17_tx_state_t *s)
| Release a V.17 modem transmit context.
int | v17_tx_free (v17_tx_state_t *s)
| Free a V.17 modem transmit context.

## Macro Definition Documentation

## CARRIER_NOMINAL_FREQ

#define CARRIER_NOMINAL_FREQ 1800.0f

The nominal frequency of the carrier, in Hertz

## V17_BRIDGE_WORD

#define V17_BRIDGE_WORD 0x8880

The 16 bit pattern used in the bridge section of the training sequence

## V17_TRAINING_END

#define V17_TRAINING_END (V17_TRAINING_SEG_4 + 48)

The end of the training, in symbols

## V17_TRAINING_SEG_1

#define V17_TRAINING_SEG_1 (V17_TRAINING_SEG_TEP_B + 48)

The start of training segment 1, in symbols

Referenced by v17_tx_restart().

## V17_TRAINING_SEG_2

#define V17_TRAINING_SEG_2 (V17_TRAINING_SEG_1 + 256)

The start of training segment 2, in symbols

## V17_TRAINING_SEG_3

#define V17_TRAINING_SEG_3 (V17_TRAINING_SEG_2 + 2976)

The start of training segment 3, in symbols

## V17_TRAINING_SEG_4

#define V17_TRAINING_SEG_4 (V17_TRAINING_SEG_3 + 64)

The start of training segment 4, in symbols

## V17_TRAINING_SEG_TEP_A

#define V17_TRAINING_SEG_TEP_A 0

The start of the optional TEP, that may preceed the actual training, in symbols

Referenced by v17_tx_restart().

## V17_TRAINING_SEG_TEP_B

#define V17_TRAINING_SEG_TEP_B (V17_TRAINING_SEG_TEP_A + 480)

The mid point of the optional TEP, that may preceed the actual training, in symbols

## V17_TRAINING_SHORT_SEG_4

#define V17_TRAINING_SHORT_SEG_4 (V17_TRAINING_SEG_2 + 38)

The start of training segment 4 in short training mode, in symbols

## V17_TRAINING_SHUTDOWN_END

#define V17_TRAINING_SHUTDOWN_END (V17_TRAINING_SHUTDOWN_A + 48)

The end of the shutdown sequence, in symbols

## Function Documentation

## v17_tx_free()

int v17_tx_free | ( | v17_tx_state_t * | s | ) |

Free a V.17 modem transmit context.

Free a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_tx_get_logging_state()

logging_state_t * v17_tx_get_logging_state | ( | v17_tx_state_t * | s | ) |

Get the logging context associated with a V.17 modem transmit context.

Get the logging context associated with a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  A pointer to the logging context

References v17_tx_state_s::logging.

## v17_tx_init()

v17_tx_state_t * v17_tx_init | ( | v17_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Initialise a V.17 modem transmit context.

Initialise a V.17 modem transmit context. This must be called before the first use of the context, to initialise its contents.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  tep | TRUE is the optional TEP tone is to be transmitted.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

Returns
  A pointer to the modem context, or NULL if there was a problem.

References CARRIER_NOMINAL_FREQ, v17_tx_state_s::carrier_phase_rate, dds_phase_ratef(), v17_tx_state_s::get_bit, v17_tx_state_s::get_bit_user_data, v17_tx_state_s::logging, v17_tx_power(), and v17_tx_restart().

## v17_tx_power()

void v17_tx_power | ( | v17_tx_state_t * | s,
|  | float | power )

Adjust a V.17 modem transmit context's output power.

Adjust a V.17 modem transmit context's power output.

Parameters

  s | The modem context.
  power | The power level, in dBm0

References v17_tx_state_s::gain.

Referenced by v17_tx_init().

## v17_tx_release()

int v17_tx_release | ( | v17_tx_state_t * | s | ) |

Release a V.17 modem transmit context.

Release a V.17 modem transmit context.

Parameters

  s | The modem context.

Returns
  0 for OK

## v17_tx_restart()

int v17_tx_restart | ( | v17_tx_state_t * | s,
|  | int | bit_rate,
|  | int | tep,
|  | int | short_train )

Reinitialise an existing V.17 modem transmit context.

Reinitialise an existing V.17 modem transmit context, so it may be reused.

Parameters

  s | The modem context.
  bit_rate | The bit rate of the modem. Valid values are 7200, 9600, 12000 and 14400.
  tep | TRUE is the optional TEP tone is to be transmitted.
  short_train | TRUE if the short training sequence should be used.

Returns
  0 for OK, -1 for parameter error.

References v17_tx_state_s::baud_phase, v17_tx_state_s::bit_rate, v17_tx_state_s::bits_per_symbol, v17_tx_state_s::carrier_phase, v17_tx_state_s::constellation, v17_tx_state_s::constellation_state, v17_tx_state_s::convolution, v17_tx_state_s::current_get_bit, v17_tx_state_s::diff, v17_tx_state_s::in_training, v17_tx_state_s::rrc_filter, v17_tx_state_s::rrc_filter_step, v17_tx_state_s::scramble_reg, v17_tx_state_s::short_train, v17_tx_state_s::training_step, V17_TRAINING_SEG_1, and V17_TRAINING_SEG_TEP_A.

Referenced by v17_tx_init().

## v17_tx_set_get_bit()

void v17_tx_set_get_bit | ( | v17_tx_state_t * | s,
|  | get_bit_func_t | get_bit,
|  | void * | user_data )

Change the get_bit function associated with a V.17 modem transmit context.

Change the get_bit function associated with a V.17 modem transmit context.

Parameters

  s | The modem context.
  get_bit | The callback routine used to get the data to be transmitted.
  user_data | An opaque pointer.

References v17_tx_state_s::current_get_bit, v17_tx_state_s::get_bit, and v17_tx_state_s::get_bit_user_data.

## v17_tx_set_modem_status_handler()

void v17_tx_set_modem_status_handler | ( | v17_tx_state_t * | s,
|  | modem_status_func_t | handler,
|  | void * | user_data )

Change the modem status report function associated with a V.17 modem transmit context.

Change the modem status report function associated with a V.17 modem transmit context.

Parameters

  s | The modem context.
  handler | The callback routine used to report modem status changes.
  user_data | An opaque pointer.

References v17_tx_state_s::status_handler, and v17_tx_state_s::status_user_data.